package provide BTS_BASE 0.5


# ***********************************************************************
#	Init function: Sets up variables
# ***********************************************************************
namespace eval ::bts {
	global quartus;
	
	#function and variable exports
	namespace export bts;
	
	#bts variable hold info on bts system such as page names, menu lists, etc
	variable bts;
	set bts(version) "BTS Version 0.5";
	set bts(app_name) "Board Test System";
	set bts(enable_gui) "0";
	set bts(tcl_shell_enable) "1";
	set bts(quit_variable) "0";
	
	
	
	set bts(print) bts_msgs;
	set bts(print_error) error;
	
	#function identifiers and their function names.
	variable bts_config_function;
	set bts_config_function(add_config_function) [list ::bts::add_config_function];
	
	#add pointers to bts comm functions.... can use to chage comm types.
	
	
}


#configuration functions for BTS:  selects function as per passed variables
#and executes
proc ::bts::bts {{instruction help} {var1 ""} {var2 ""} {var3 ""} {var4 ""} {var5 ""} {var6 ""}} {
	variable bts;
	variable bts_config_function;	
	
	switch -exact -- $instruction {
		status {

			
				foreach index [array names bts] {
					::bts::bts_base_print std "$index : $bts($index)\n";
				}
			

		}
		help {
			::bts::bts_base_print std "Available Commands are :\n";
			::bts::bts_base_print std "help ";
			::bts::bts_base_print std "status ";
			::bts::bts_base_print std "set ";
			foreach index [lsort -dictionary [array names bts_config_function]] {
				::bts::bts_base_print std "$index ";
			}
			::bts::bts_base_print std "\n";
		}
		set {
			if {[regexp $var1 [array names bts]]} {
				set return_val [set bts($var1) $var2];
			} else {
				::bts::bts_base_print error "$var1 is an invalid setting\n";
			}
		}
		add_config_function {
			if {[regexp $var1 [array names bts_config_function]]} {				
				::bts::bts_base_print error "Function $var1 already exists!\n";
			} else {
				set return_val [::bts::add_config_function $var1 $var2];
			}			
		}
		default {
			set command 0;
			foreach index [array names bts_config_function] {
				if {[regexp $index $instruction] == 1} {
					set command $bts_config_function($index);
				}
			}
			if {$command == 0} {
				::bts::bts_base_print error "Error:  $instruction is invalid\n";
			} else {
				set return_val [$command $var1 $var2 $var3 $var4 $var5 $var6];
				return $return_val;
			}
		}
	}
}

#add a config function to config proc
proc ::bts::add_config_function {function_name function_call} {
	variable bts_config_function;
	set bts_config_function($function_name) [list $function_call];
}


#base bts print
proc ::bts::bts_base_print {type text} {
	variable bts;
	if {$bts(enable_gui) != "0"} {
		if {$type == "std"} {
			::bts::gui::print $bts(print) $text;
		} else {
			::bts::gui::print $bts(print) $text error;
		}
	} else {
		puts -nonewline $text;
	}
}


