package provide BTS_GUI 0.1

# If using Quartus, This script must be run using the Quartus II Shell
if {[info exist ::quartus]} {
    if { ![string equal $::quartus(nameofexecutable) quartus_sh] } {
        set msg "BTS should be invoked from the command line using the Quartus II Shell.\nUsage: quartus_sh -t main.tcl"
        puts $msg
        catch { tk_messageBox -type ok -message $msg -icon error -title "BTS Error"}
        return
    } else {
	    init_tk
    }
}

# Required Packages
package require BWidget;
package require BTS_COMM;

# ***********************************************************************
#	Main GUI Functions
# ***********************************************************************
namespace eval ::bts::gui {
	namespace import ::bts::bts;
	namespace export print;
		
	#add config functionality
	# bts add_config_function add_menu_item [list ::bts::gui::add_menu_item];
	# bts add_config_function add_main_tab [list ::bts::gui::add_main_tab];
	# bts add_config_function add_lower_tab [list ::bts::gui::add_lower_tab];
	# bts add_config_function start_gui [list ::bts::gui::start_bts_gui];
	# bts add_config_function locate_tab [list ::bts::gui::locate_tab];
	# bts add_config_function raise_tab [list ::bts::gui::raise_tab];
	bts add_config_function gui [list ::bts::gui::config];
	
	variable bts_gui;
	# set bts_gui(menu_list) {
		# "&BTS" {} {} 0 {
			# {command "&Test All" {} "Test All Features" {} -command ::bts::menu::test_all}
			# {command "&Save" {} "Save Test Output to a File" {} -command ::bts::menu::save_output}
			# {separator}
			# {command "&Exit" {} "Exit BTS" {} -command ::bts::gui::exit}
		# }
		# "&COMM Settings" {} {} 0 {			
			# {cascad "&Open Port" {} {} 0 {
					# {command "RS232 Com1" {} "Open Com Port 1" {} -command {::bts::gui::menu::open_port rs232_com1}}
					# {command "RS232 Com2" {} "Open Com Port 1" {} -command {::bts::gui::menu::open_port rs232_com2}}
					# {command "RS232 ttyS0" {} "Open Device ttyS0" {} -command {::bts::gui::menu::open_port rs232_ttyS0}}
					# {command "RS232 ttyS1" {} "Open Device ttyS1" {} -command {::bts::gui::menu::open_port rs232_ttyS1}}
			# }}
			# {separator}
			# {command "&Close Port" {} "Close Current Open Port" {} -command ::bts::gui::menu::close_port}
		# }
	# }
	
	set bts_gui(menu_list) {
		"&BTS" {} {} 0 {
			{cascad "&Open Port" {} {} 0 {
					{command "RS232 Com1" {} "Open Com Port 1" {} -command {::bts::gui::menu::open_port rs232_com1}}
					{command "RS232 Com2" {} "Open Com Port 1" {} -command {::bts::gui::menu::open_port rs232_com2}}
					{command "RS232 ttyS0" {} "Open Device ttyS0" {} -command {::bts::gui::menu::open_port rs232_ttyS0}}
					{command "RS232 ttyS1" {} "Open Device ttyS1" {} -command {::bts::gui::menu::open_port rs232_ttyS1}}
			}}
			{separator}
			{command "&Close Port" {} "Close Current Open Port" {} -command ::bts::gui::menu::close_port}
			{separator}
			{command "&Exit" {} "Exit BTS" {} -command ::bts::gui::menu::exit}
		}
	}
	
	set bts_gui(tcl_shell_enable) 0;
	#define print location for bts messages
	
	set bts_gui(print) bts_msgs;
	set bts_gui(quit_variable) 0;
	set bts_gui(started) 0;
	
	
	variable bts_main_tab_defines;
	variable bts_main_tab_names;
	variable bts_main_tab_frames;
	
	
	variable bts_lower_tab_defines;
	variable bts_lower_tab_names;
	variable bts_lower_tab_frames;
	
	set bts_lower_tab_defines(bts_msgs) [list "BTS Msgs" "::bts::gui::build_msg_tab" 0];
	
	#pointer to printable text widgets
	variable bts_print_windows;
	set bts_print_windows(1) 1;
}

#bts gui config function
proc ::bts::gui::config {{my_instruction ""} {var2 ""} {var3 ""} {var4 ""} {var5 ""} {var6 ""}} {
	variable bts_gui;
	
	if {$my_instruction == ""} {
		set my_instruction "help";
	}
	
	switch -exact -- $my_instruction {
		help {
			::bts::bts_base_print std "Available functions are:\n";
			::bts::bts_base_print std "help status set add_menu_tab add_main_tab \n";
			::bts::bts_base_print std "add_lower_tab start locate_tab raise_tab\n";
		}
		status {
			::bts::bts_base_print std "Current GUI Status is:\n";
			foreach index [array names bts_gui] {
				::bts::bts_base_print std "$index : $bts_gui($index)\n";
			}
		}
		set {
			if {regexp $var2 [array names bts_gui]} {
				set return_val [set $bts_gui($var2) $var3];
			} else {
				::bts::bts_base_print error "$var2 is an invalid setting\n";
			}
		}
		add_menu_item {	
			if {$var2 == ""} {
				
			} else {
				::bts::gui::add_menu_item $var2;
			}
		}
		add_main_tab {
			 ::bts::gui::add_main_tab $var2 $var3 $var4 $var5;
		}
		insert_main_tab {
			set return_val [::bts::gui::insert_main_tab $var2 $var3];
			return $return_val;
		}
		insert_lower_tab {
			set return_val [::bts::gui::insert_lower_tab $var2 $var3];
			return $return_val;
		}
		add_lower_tab {
			 ::bts::gui::add_lower_tab $var2 $var3 $var4 $var5;
		}
		start {
			if {$bts_gui(started)} {
				::bts::bts_base_print error "BTS GUI is already running!\n";
			} else {
				set bts_gui(started) 1;
				::bts::bts set enable_gui 1;
				::bts::gui::start_bts_gui;
			}
		}
		locate_tab {
			 set return_val [::bts::gui::locate_tab $var2 $var3 $var4];
		}
		raise_tab {
			 set return_val [::bts::gui::raise_tab $var2 $var3];
		}
		default {
			::bts::bts_base_print error "$var2 is an invalid instruction\n";
		}
	}
	
}

#create gui, menus, main tab notebook, 
proc ::bts::gui::start_bts_gui {} {
	variable bts_gui;
	
	
	option add *TitleFrame.l.font {helvetica 11 bold italic};
	option add *LabelFrame.l.font {helvetica 10};
	
	wm withdraw .;
	wm title . "$::bts::bts(app_name)";
	
	#set size variables for window
	set bts_gui(max_height) [winfo screenheight .];
	set bts_gui(max_width) [winfo screenwidth .];
	
	if {$bts_gui(max_height) < 1000 } {
		set bts_gui(height) [expr $bts_gui(max_height) - 100];
	} else {
		set bts_gui(height) 800;
	}
	
	if {$bts_gui(max_width) < 1200 } {
		set bts_gui(width) [expr $bts_gui(max_width) - 100];
	} else {
		set bts_gui(width) 1015;
	}
	
	#create the base frame with menu items
	set bts_gui(top) [ MainFrame .mainframe -height  800 -menu $bts_gui(menu_list) -textvariable status -width 1000 -separator both];
	
	#add the version indicator
	$bts_gui(top) addindicator -text "$::bts::bts(version)";
	
	#put everything together
	pack $bts_gui(top) -fill both -expand yes
	set bts_gui(mainframe) [$bts_gui(top) getframe];

	
	if {$bts_gui(tcl_shell_enable)} {
		::bts::gui::config add_main_tab tclshell "BTS TCL Shell" "::bts::shell::build_tclshell";
	}
	
	#create main notebook pages
	#this allows main tab create functions to add lower tab message windows.
	::bts::gui::create_main_tabs;
	
	#create lower tabs window
	::bts::gui::create_lower_tabs;
	
	update idletasks
	#exit properly
	bind $bts_gui(mainframe) <Destroy> {::bts::gui::menu::exit }
	
	BWidget::place . 0 0 center
		
	wm deiconify .
	raise .
	focus -force .
	
	#set window size
	wm geom . ${bts_gui(width)}x${bts_gui(height)}+0+0
	
	#vwait ::bts::gui::menu::quit_var;
}

#create lower tabs
proc ::bts::gui::create_lower_tabs {} {
	variable bts_gui;
	variable bts_lower_tab_defines;
	variable bts_lower_tab_names;
	
	#create lower notebook widget
	set bts_gui(lower_notebook) [NoteBook $bts_gui(mainframe).lower_notebook -fg black -font {helvetica 10 bold italic}];
	place $bts_gui(lower_notebook) -relheight 0.25  -relwidth 1 -width -20 -relx 0 -x 10 -rely 0.73 -y 5;
	
	foreach tab [array names bts_lower_tab_defines] {
		#get the tab title
		set tab_title [lindex $bts_lower_tab_defines($tab) 0];
		#get the specified tab build function
		set tab_build_function [list [lindex $bts_lower_tab_defines($tab) 1]];
		#add the tab and get the tab's frame
		set frame_var [::bts::gui::insert_lower_tab $tab $tab_title];
		#build the tab
		$tab_build_function $bts_gui(lower_notebook) $tab $frame_var;
	}
	
	#order the pages as specified
	foreach tab [array names bts_lower_tab_defines] {
		set tab_index [lindex $bts_lower_tab_defines($tab) 2];
		if {[regexp \[0-9\]+ $tab_index]} {
			$bts_gui(lower_notebook) move $tab $tab_index;
		}
	}
	
	#raise the first tab 
	set first_page [$bts_gui(lower_notebook) pages 0];
	$bts_gui(lower_notebook) raise $first_page
		
}

#create main tabs
proc ::bts::gui::create_main_tabs {} {
	variable bts_gui;
	variable bts_main_tab_defines;
	variable bts_main_tab_names;
	
	#create main notebook widget
	set bts_gui(main_notebook) [NoteBook $bts_gui(mainframe).main_notebook -fg black -font {helvetica 10 bold italic}];
	place $bts_gui(main_notebook) -relheight 0.73  -relwidth 1 -width -20 -relx 0 -x 10 -rely 0 -y 5;
	
	foreach tab [array names bts_main_tab_defines] {
		#get the tab title
		set tab_title [lindex $bts_main_tab_defines($tab) 0];
		#get the specified tab build function
		set tab_build_function [list [lindex $bts_main_tab_defines($tab) 1]];
		#add the tab and get the tab's frame
		set frame_var [::bts::gui::insert_main_tab $tab $tab_title];
		#build the tab
		$tab_build_function $bts_gui(main_notebook) $tab $frame_var;
	}
	
	#order the pages as specified
	foreach tab [array names bts_main_tab_defines] {
		set tab_index [lindex $bts_main_tab_defines($tab) 2];
		if {[regexp \[0-9\]+ $tab_index]} {
			$bts_gui(main_notebook) move $tab $tab_index;
		}
	}
	
	if {$bts_gui(tcl_shell_enable)} {
		$bts_gui(main_notebook) move tclshell end;
	}
	
	#raise the first tab 
	set first_page [$bts_gui(main_notebook) pages 0];
	$bts_gui(main_notebook) raise $first_page;
		
}

# ***********************************************************************
#	Functions to build gui components
# ***********************************************************************

#add tab to lower notebook tab
proc ::bts::gui::insert_lower_tab {tab_name tab_title} {
	variable bts_gui;
	variable bts_lower_tab_names;
	variable bts_lower_tab_frames;
	
	#insert the page
	set bts_lower_tab_names($tab_name) [$bts_gui(lower_notebook) insert end $tab_name -text $tab_title];
	#create frame pointer
	set bts_lower_tab_frames($tab_name) [$bts_gui(lower_notebook) getframe $tab_name];
	
	#return the frame
	return $bts_lower_tab_frames($tab_name);
}

#add tab to main notebook tab
proc ::bts::gui::insert_main_tab {tab_name tab_title} {
	variable bts_gui;
	variable bts_main_tab_names;
	variable bts_main_tab_frames;
	
	#insert the page
	set bts_main_tab_names($tab_name) [$bts_gui(main_notebook) insert end $tab_name -text $tab_title];
	#create frame pointer
	set bts_main_tab_frames($tab_name) [$bts_gui(main_notebook) getframe $tab_name];
	
	#return the frame
	return $bts_main_tab_frames($tab_name);
}	


# ***********************************************************************
#	Pre-created tab build functions
# ***********************************************************************
#message tabs
proc ::bts::gui::build_msg_tab {notebook tab tab_frame} {
	variable bts_print_windows;
	
	#----create msg_window
	
	#create text widget
	set bts_print_windows($tab) [text $tab_frame.log_window -setgrid false -fg black -font {Courier}  \
						   -yscrollcommand "$tab_frame.log_scroll set"];
	
	#create scrollbar
	scrollbar $tab_frame.log_scroll -orient vertical -command "$bts_print_windows($tab) yview";
	
	#place them
	place $tab_frame.log_scroll -relheight 1 -width 15 -rely 0 -relx 1 -x -15 ;
	place $bts_print_windows($tab) -relheight 1 -relwidth 1 -width -15 -rely 0 -relx 0;
	
	#configure the print tags
	::bts::gui::configure_print_tags $bts_print_windows($tab);
	
	return $bts_print_windows($tab);
}

#default intro page
proc ::bts::gui::build_default_intro {notebook tab tab_frame} {
	variable bts_print_windows;
	
	
	#move intro tab to front
	$notebook move $tab 0;
	
	#create canvas for Images.. Altera Logo, Nios logo, board part logo
	set intro_canvas [canvas $tab_frame.canvas -borderwidth 3];
	
	#text widget
	set intro_text [text $tab_frame.intro_text -setgrid false -fg black -font {Courier}  \
			-yscrollcommand "$tab_frame.scroll set" -wrap word];
	
	scrollbar $tab_frame.scroll -orient vertical -command "$intro_text yview";
	
	# Creating tags to control display of message like color, font, size etc.
	::bts::gui::configure_print_tags $intro_text;
	
	#put everything in the frame
	place $tab_frame.scroll -relheight 1 -height -20 -width 15 -rely 0 -y 15 -relx 0.5 ;
	place $intro_text -relheight 1 -height -20 -rely 0 -y 15 -relwidth 0.5 -width -5 -relx 0 -x 5;
	place $intro_canvas -relheight 1 -height -20 -rely 0 -y 15 -relwidth 0.5 -width -20 -relx 0.5 -x 15;
	
	
	#put default pics in canvas widget
	$intro_canvas create image 10 25 -image [image create photo -file ./BTS_BASE/pics/stratix_2.gif] -anchor nw;
	$intro_canvas create image 200 10 -image [image create photo -file ./BTS_BASE/pics/quartus_2.gif] -anchor nw;
	$intro_canvas create image 150 180 -image [image create photo -file ./BTS_BASE/pics/cyclone_black.gif] -anchor nw;
	$intro_canvas create image 10 280 -image [image create photo -file ./BTS_BASE/pics/stratix.gif] -anchor nw;
	$intro_canvas create image 200 380 -image [image create photo -file ./BTS_BASE/pics/stratix_gx.gif] -anchor nw;
	
	set bts_print_windows($tab) $intro_text;
	return bts_print_windows($tab);
}

# ***********************************************************************
#	Functions to build gui components
# ***********************************************************************

#add tab to lower notebook tab
proc ::bts::gui::insert_lower_tab {tab_name tab_title} {
	variable bts_gui;
	variable bts_lower_tab_names;
	variable bts_lower_tab_frames;
	
	#insert the page
	set bts_lower_tab_names($tab_name) [$bts_gui(lower_notebook) insert end $tab_name -text $tab_title];
	#create frame pointer
	set bts_lower_tab_frames($tab_name) [$bts_gui(lower_notebook) getframe $tab_name];
	
	#return the frame
	return $bts_lower_tab_frames($tab_name);
}

#add tab to main notebook tab
proc ::bts::gui::insert_main_tab {tab_name tab_title} {
	variable bts_gui;
	variable bts_main_tab_names;
	variable bts_main_tab_frames;
	
	#insert the page
	set bts_main_tab_names($tab_name) [$bts_gui(main_notebook) insert end $tab_name -text $tab_title];
	#create frame pointer
	set bts_main_tab_frames($tab_name) [$bts_gui(main_notebook) getframe $tab_name];
	
	#return the frame
	return $bts_main_tab_frames($tab_name);
}

#	add menu item	
proc ::bts::gui::add_menu_item {new_menu_item} {
	variable bts_gui;
	
	set bts_gui(menu_list) [concat $bts_gui(menu_list) $new_menu_item];
}


proc ::bts::gui::add_lower_tab {tab_name tab_title tab_builder {tab_loc ""}} {
	variable bts_gui;
	variable bts_lower_tab_defines;
	
	set bts_lower_tab_defines($tab_name) [list $tab_title $tab_builder $tab_loc];
	
}

proc ::bts::gui::add_main_tab {tab_name tab_title tab_builder {tab_loc ""}} {
	variable bts_gui;
	variable bts_main_tab_defines;
	
	
	set bts_main_tab_defines($tab_name) [list $tab_title $tab_builder $tab_loc];
	
}

proc ::bts::gui::locate_tab {target_notebook tab tab_loc} {
	variable bts_gui;
	
	if {$target_notebook == "lower"} {
		set notebook $bts_gui(lower_notebook);
		$notebook move $tab $tab_loc;
	} else {
		if {$target_notebook == "main"} {
		set notebook $bts_gui(main_notebook);
		$notebook move $tab $tab_loc;
		} else {
			print bts_msgs "locate_tab targets are lower and main.\n"
		}
	}
	
}

proc ::bts::gui::raise_tab {target_notebook tab} {
	variable bts_gui;
	
	if {$target_notebook == "lower"} {
		set notebook $bts_gui(lower_notebook);
		$notebook raise $tab;
	} else {
		if {$target_notebook == "main"} {
		set notebook $bts_gui(main_notebook);
		$notebook raise $tab;
		} else {
			print bts_msgs "raise_tab targets are lower and main.\n"
		}
	}
	
}
# ***********************************************************************
#	BTS Print Functions
# ***********************************************************************

# Contigure text window tags 
proc ::bts::gui::configure_print_tags { text_window } {
	#Add tags as needed
	$text_window tag configure bold -font {Courier 10 bold};
	$text_window tag configure error -foreground red -font {Courier 10};
	$text_window tag configure warning -foreground blue -font  {Courier 10};
	$text_window tag configure normal -font {Courier 10};
}

#msg windows
proc ::bts::gui::print {target text {tag normal}} {
	variable bts_print_windows;
	foreach window $target {
		$bts_print_windows($window) insert end "$text" $tag;
		$bts_print_windows($window) yview moveto 10;
	}
}


# ***********************************************************************
#	Menu Functions
# ***********************************************************************

namespace eval ::bts::gui::menu {

}

proc ::bts::gui::menu::exit {} {
	variable quit_var;
	
	#this is one i missed....
	::bts::bts set enable_gui 0;
	
	if {[::bts::bts comm is_port_open]} {
		::bts::gui::menu::close_port;
	}
	set ::bts::gui::bts_gui(quit_variable) 1;
	destroy .
}

proc ::bts::gui::menu::open_port {port_name} {
	::bts::bts comm set bts_port $port_name;
	::bts::bts comm open_bts_port;
	::bts::bts comm enable_read_handler;
}

proc ::bts::gui::menu::close_port {} {
	
	::bts::bts comm close_bts_port;
}
