package provide BTS_NIOS_STAMP 0.1

# ***********************************************************************
#	Init function: Sets up variables
# ***********************************************************************
namespace eval ::bts::nios_stamp {
	#add te userio config function to base bts
	::bts::bts add_config_function nios_stamp "::bts::nios_stamp::config";
	
	variable bts_nios_stamp;
	variable bts_nios_stamp_flags;
	
	#flag for checking if a test is running
	set bts_nios_stamp_flags(not_in_test) 1;
	
	#Setup supported Nios Stamp Features
	set bts_nios_stamp(santa_cruz) 0;
	set bts_nios_stamp(flash) 0;
	set bts_nios_stamp(sram) 0;
	set bts_nios_stamp(ethernet) 0;
	set bts_nios_stamp(rs232a) 0;
	set bts_nios_stamp(rs232b) 0;
	
}

proc ::bts::nios_stamp::config {instruction var2 var3 var4 var5 var6} {
	variable bts_nios_stamp;
	variable bts_nios_stamp_flags;
	
	if {$instruction == ""} {
		set insruction "help";
	}
	
	switch -exact -- $instruction {
		help {
			::bts::bts_base_print std "To be added!\n";
		}
		status {
			::bts::bts_base_print std "Current NIOS Stamp Settings are:\n";
			foreach index [array names bts_nios_stamp] {
				::bts::bts_base_print std "$index : $bts_nios_stamp($index)\n";
			}
		}
		set {
			if {[regexp $var2 [array names bts_nios_stamp ]]} {
				set bts_nios_stamp($var2) $var3;
			} else {
				::bts::bts_base_print error "$var2 is nat a valid user_io assignment.\n";
			}
		}
		build {
			return [::bts::nios_stamp::build $var3 $var4 $var5];
		}
		default {
			::bts::bts_base_print error "$var2 is an invalid user io instruction\n";
		}
	}
	
}

proc ::bts::nios_stamp::build {notebook tab frame} {
	variable bts_nios_stamp;
	variable bts_nios_stamp_flags;
	
	::bts::bts gui add_lower_tab nios_stamp "NIOS Stamp Msgs" "::bts::gui::build_msg_tab" 2;
	
	set nios_stamp_frame [frame $frame.nios_stamp_frame];
	
	#build santa cruz stuff
	if {[lindex $bts_nios_stamp(santa_cruz) 0]} {
		set scruz_frame [frame $nios_stamp_frame.scruz_frame -borderwidth 3 -relief sunken];
		set scruz_button [button $scruz_frame.button_start -text "Start Test" \
			-command {::bts::nios_stamp::scruz::start_test \
					[lindex $::bts::nios_stamp::bts_nios_stamp(santa_cruz) 0] \
					[lindex $::bts::nios_stamp::bts_nios_stamp(santa_cruz) 1]}];
					
		set scruz_label [label $scruz_frame.label -text "Santa Cruz IO"];
		pack $scruz_label -in $scruz_frame -side top -anchor nw;
		pack $scruz_button -in $scruz_frame -side top -anchor nw;
		pack $scruz_frame -in $nios_stamp_frame -side top -anchor nw  -fill x ;
		
	}
	
	#build SRAM stuff
	if {[lindex $bts_nios_stamp(sram) 1]} {
		set sram_frame [frame $nios_stamp_frame.sram_frame -borderwidth 3 -relief sunken];
		set sram_start_button [button $sram_frame.button_start -text "Start Tests" \
			-command {::bts::nios_stamp::mem::start_test \
				[lindex $::bts::nios_stamp::bts_nios_stamp(sram) 0]\
				[lindex $::bts::nios_stamp::bts_nios_stamp(sram) 1]\
				[lindex $::bts::nios_stamp::bts_nios_stamp(sram) 2] sram}];
		set sram_start_button_data [button $sram_frame.button_start_data -text "Start Walking Ones - Data" \
			-command {::bts::nios_stamp::mem::start_test \
				[lindex $::bts::nios_stamp::bts_nios_stamp(sram) 0]\
				[lindex $::bts::nios_stamp::bts_nios_stamp(sram) 1]\
				[lindex $::bts::nios_stamp::bts_nios_stamp(sram) 2] sram walk_data}];
		set sram_start_button_add [button $sram_frame.button_start_add -text "Start Walking Ones - Address" \
			-command {::bts::nios_stamp::mem::start_test \
				[lindex $::bts::nios_stamp::bts_nios_stamp(sram) 0]\
				[lindex $::bts::nios_stamp::bts_nios_stamp(sram) 1]\
				[lindex $::bts::nios_stamp::bts_nios_stamp(sram) 2] sram walk_address}];
		set sram_label [label $sram_frame.label -text "SRAM"];
		pack $sram_label -in $sram_frame -side top -anchor nw;
		pack $sram_start_button $sram_start_button_data $sram_start_button_add -in $sram_frame -side left -anchor nw;
		pack $sram_frame -in $nios_stamp_frame -side top -anchor nw -fill x ;
		
	}
	
	#build flash stuff
	if {[lindex $bts_nios_stamp(flash) 1]} {
		set flash_frame [frame $nios_stamp_frame.flash_frame -borderwidth 3 -relief sunken];
		
		set flash_start_button [button $flash_frame.button_start -text "Start Tests" \
			-command {::bts::nios_stamp::mem::start_test \
				[lindex $::bts::nios_stamp::bts_nios_stamp(flash) 0]\
				[lindex $::bts::nios_stamp::bts_nios_stamp(flash) 1]\
				[lindex $::bts::nios_stamp::bts_nios_stamp(flash) 2] flash}];
		set flash_start_button_data [button $flash_frame.button_start_data -text "Start Walking Ones - Data" \
			-command {::bts::nios_stamp::mem::start_test \
				[lindex $::bts::nios_stamp::bts_nios_stamp(flash) 0]\
				[lindex $::bts::nios_stamp::bts_nios_stamp(flash) 1]\
				[lindex $::bts::nios_stamp::bts_nios_stamp(flash) 2]  flash walk_data}];
		set flash_start_button_add [button $flash_frame.button_start_add -text "Start Walking Ones - Address" \
			-command {::bts::nios_stamp::mem::start_test \
				[lindex $::bts::nios_stamp::bts_nios_stamp(flash) 0]\
				[lindex $::bts::nios_stamp::bts_nios_stamp(flash) 1]\
				[lindex $::bts::nios_stamp::bts_nios_stamp(flash) 2]  flash walk_address}];
		set flash_erase [button $flash_frame.button_erase -text "Erase Flash" \
			-command {::bts::nios_stamp::mem::flash_erase\
					[lindex $::bts::nios_stamp::bts_nios_stamp(flash) 0]}];
		set flash_label [label $flash_frame.label -text "Flash"];
		pack $flash_label -in $flash_frame -side top -anchor nw;
		pack $flash_start_button $flash_start_button_data $flash_start_button_add $flash_erase -in $flash_frame -side left -anchor nw;
		
		pack $flash_frame -in $nios_stamp_frame -side top -anchor nw -fill x ;
	}
	if {[lindex $bts_nios_stamp(ethernet) 0]} {
		set ether_frame [frame $nios_stamp_frame.ether_frame -borderwidth 3 -relief sunken];
		
		#buttons
		set get_dhcp_but [button $ether_frame.get_dhcp_but -text "Get DHCP Address" \
		-command {::bts::nios_stamp::ethernet::ether_get_dhcp}];
		
		set blink_leds_but [button $ether_frame.blink_leds_but -text "Blink Ethernet Leds" \
		-command {::bts::nios_stamp::ethernet::ether_blink_leds}];
		
		set win_ping_but [button $ether_frame.win_ping_but -text "Ping Board - Windows" \
		-command {::bts::nios_stamp::ethernet::ether_ping windows}];
		
		set unix_ping_but [button $ether_frame.unix_ping_but -text "Ping Board - Unix" \
		-command {::bts::nios_stamp::ethernet::ether_ping unix}];
		
		set kill_but [button $ether_frame.kill_but -text "Terminate Ethernet" \
		-command {::bts::nios_stamp::ethernet::ether_kill}];
		
		set ether_label [label $ether_frame.label -text "Ethernet"];
		pack $ether_label -in $ether_frame -side top -anchor nw;
		pack $get_dhcp_but $blink_leds_but $win_ping_but $unix_ping_but $kill_but -in $ether_frame -side left -anchor nw;
		
		pack $ether_frame -in $nios_stamp_frame -side top -anchor nw -fill x ;
	}
		
	pack $nios_stamp_frame -in $frame -side top -fill both -anchor nw;
}

#print function for nios stamp
proc ::bts::nios_stamp::print {text {tag normal}} {
	
	::bts::gui::print nios_stamp $text $tag;
}


#test for the santa cruz
namespace eval ::bts::nios_stamp::scruz {
	variable scruz_write_data;
	variable scruz_read_data;
	variable input_address;
	variable output_address;
}
proc ::bts::nios_stamp::scruz::start_test {out_address in_address} {
	variable scruz_write_data;
	variable scruz_read_data;
	variable input_address;
	variable output_address;
	
	
	
	if {$::bts::nios_stamp::bts_nios_stamp_flags(not_in_test)} {
		
		#save the addresses for future use
		set output_address $out_address;
		set input_address $in_address;
		
		#raise the nios_stamp message window
		::bts::bts gui raise_tab lower nios_stamp;
		::bts::nios_stamp::print "Starting Santa Cruz Test\n" bold;
		set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 0;
		set scruz_write_data 1;
		#do a pio write to the scruz output pio
		if {[::bts::bts comm write_port 3 1 [list $output_address [format "%x" $scruz_write_data]]]} {
			::bts::nios_stamp::print "Port Not Open!!\n" error;
			set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
			return 1;
		}
		
		#do a pio read from the scruz input pio
		::bts::bts comm write_port 4 1 [list $input_address] "::bts::nios_stamp::scruz::test_and_return";
		
	} else {
		::bts::nios_stamp::print "Currently running a test!!\n" error;
	}
}

proc ::bts::nios_stamp::scruz::test_and_return {number_list} {
	variable scruz_write_data;
	variable scruz_read_data;
	variable input_address;
	variable output_address;
	
	set number [lindex $number_list 0];
	set number_formated [format "%u" "0x$number"];
	
	if {$number_formated != "$scruz_write_data"} {
		::bts::nios_stamp::print "Wrote 0x[format "%x" $scruz_write_data] but Read 0x$number\n" error;
	}
	
	
	#if we have not reached the end value, do the next one.
	if { [format "%x" $scruz_write_data] != "100000"} {
		set scruz_write_data [expr $scruz_write_data*2];
		#do a pio write to the scruz output pio
		::bts::bts comm write_port 3 1 [list $output_address [format "%x" $scruz_write_data]];
		
		#do a pio read from the scruz input pio
		::bts::bts comm write_port 4 1 [list $input_address] "::bts::nios_stamp::scruz::test_and_return";
	} else {
		::bts::nios_stamp::print "Santa Cruz IO Test Complete\n";
		set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
	}
}

#test for sram..
namespace eval ::bts::nios_stamp::mem {
	variable base_address;
	variable end_address;
	variable data_size;
	
	variable errors;
	variable read_data;
	variable got_data;
	
	set errors(total) 0;

}

#procedure to start the mem test
proc ::bts::nios_stamp::mem::start_test {base_add end_add d_size mem_type {which_test "all"}} {
	variable base_address;
	variable end_address;
	variable data_size;
	variable errors;
	
	if {$::bts::nios_stamp::bts_nios_stamp_flags(not_in_test)} {
		#raise the nios_stamp message window
		::bts::bts gui raise_tab lower nios_stamp;
		set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 0;
		
		#set some variables
		set base_address [format "%u" "0x$base_add"];
		set end_address [format "%u" "0x$end_add"];
		set data_size $d_size;
		set errors(total) 0;
		
		#init errors array -- sets total errors to 0, and gets rid of 
		#array elements for previously created errors
		foreach element [array names errors] {
			if {$element == "total"} {
				set errors(total) 0;
			} else {
				unset errors($element);
			}	
		}
		
		#do tests
		::bts::nios_stamp::print "Starting Test\n" bold;
		
		#which type of device (sram, flash)
		switch -exact -- $mem_type {
			sram {
				#but which test??
				if {$which_test == "all" | $which_test == "walk_data"} {
					::bts::nios_stamp::mem::walking_data_test_sram;
				}
				
				if {$which_test == "all" | $which_test == "walk_address"} {
					::bts::nios_stamp::mem::walking_address_test_sram;
				}
				
			}
			flash {
				#but which test??
				if {$which_test == "all" | $which_test == "walk_data"} {
					::bts::nios_stamp::mem::walking_data_test_flash;
					::bts::nios_stamp::mem::flash_erase_sector $base_address 0;
				}
				
				if {$which_test == "all" | $which_test == "walk_address"} {
					::bts::nios_stamp::mem::walking_address_test_flash;
					::bts::nios_stamp::mem::flash_erase $base_add;
				}
			}
		}
		

		::bts::nios_stamp::print "There were $errors(total) error(s).\n";
		::bts::nios_stamp::print "Test Complete\n" bold;
		set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
		
	} else {
		::bts::nios_stamp::print "Currently running a test!!\n" error;
	}
}

#this function is called when read data is returned from the nios system
#it is called by the handler function in bts_comm
proc ::bts::nios_stamp::mem::return_read_data {number_list} {
	variable read_data;
	variable got_data;
	
	#get the data we want
	set number [lindex $number_list 0];
	set number_formated [format "%u" "0x$number"];
	
	#::bts::nios_stamp::print "GOT\n";
	
	#return it to the function
	set read_data $number_formated;
	set got_data 1;
	
}


## SRAM Functions
#walking ones on data
proc ::bts::nios_stamp::mem::walking_data_test_sram {} {
	#globals
	variable base_address;
	variable end_address;
	variable data_size;
	variable errors;
	variable read_data;
	variable got_data;
	
	#just for here
	set current_address $base_address;
	set current_data 1;
	
	#pretty output
	::bts::nios_stamp::print "Walking Ones on Data\n";
	
	for {set x 0} {$x < $data_size} {incr x} {
		#change the address and data to hex
		set hex_add [format "%x" $current_address];
		set hex_data [format "%x" $current_data];
		
		#write the data to the address
		#command 1 is an avalon write
		#check is port is open
		if {[::bts::bts comm write_port 1 1 [list $hex_add $hex_data]]} {
			::bts::nios_stamp::print "Port Not Open!!\n" error;
			set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
			return 1;
		}
		
		
		#send command to read data back (2) 
		#and wait until we have itn";
		::bts::bts comm write_port 2 1 [list $hex_add] "::bts::nios_stamp::mem::return_read_data";
		
		#wait until data is returned
		set got_data 0;
		vwait ::bts::nios_stamp::mem::got_data;
		
		#check the data and record the error if there is any
		if {$hex_data != [format "%x" $read_data]} {
			::bts::nios_stamp::print "Wrote 0x$hex_data to Address 0x$hex_add, but read back 0x[format "%x" $read_data]\n";
			set errors(total) [expr $errors(total) + 1];
			#store the error data in an element represented by the error add
			set errors($hex_add) [format "%x" $read_data];
		}
		
		#incr add and shift data
		set current_data [expr $current_data << 1];
		#for now assume 32 bit data
		set current_address [expr $current_address + 4];  
		
	}
	
}

#walking ones on address
proc ::bts::nios_stamp::mem::walking_address_test_sram {} {
	#globals
	variable base_address;
	variable end_address;
	variable data_size;
	variable errors;
	variable read_data;
	variable got_data;
	
	#pretty output
	::bts::nios_stamp::print "Walking Ones on Address\n";
	
	#just for here
	set current_data [format "%u" "0xa5a5a5a5"];
	
	for {set current_address [expr $base_address + 4]} {$current_address < $end_address} {set current_address [expr $current_address<<1] } {
		#change the address and data to hex
		set hex_add [format "%x" $current_address];
		set hex_data [format "%x" $current_data];
		
		#write the data to the address
		#command 1 is an avalon write
		#::bts::bts comm write_port 1 1 [list $hex_add $hex_data];
		#check if port is open
		if {[::bts::bts comm write_port 1 1 [list $hex_add $hex_data]]} {
			::bts::nios_stamp::print "Port Not Open!!\n" error;
			set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
			return 1;
		}
		
		#send command to read data back (2) 
		#and wait until we have it
		::bts::bts comm write_port 2 1 [list $hex_add] "::bts::nios_stamp::mem::return_read_data";
		set got_data 0;
		vwait ::bts::nios_stamp::mem::got_data;
		
		#check the data and record the error if there is any
		if {$hex_data != [format "%x" $read_data]} {
			::bts::nios_stamp::print "Wrote 0x$hex_data to Address 0x$hex_add, but read back 0x[format "%x" $read_data]\n";
			set errors(total) [expr $errors(total) + 1];
			#store the error data in an element represented by the error add
			set errors($hex_add) [format "%x" $read_data];
		}
		
		#toggle data
		if {$current_data == [format "%u" "0xa5a5a5a5"]} {
			set current_data [format "%u" "0x5a5a5a5a"];
		} else {
			set current_data [format "%u" "0xa5a5a5a5"];
		}
		
	}
	
}

###Flash Functions
#walking ones on data
proc ::bts::nios_stamp::mem::walking_data_test_flash {} {
	#globals
	variable base_address;
	variable end_address;
	variable data_size;
	variable errors;
	variable read_data;
	variable got_data;
	
	#just for here
	set current_address 0;
	set current_data 1;
	set base_address_hex [format "%x" $base_address];
	
	#pretty output
	::bts::nios_stamp::print "Walking Ones on Data\n";
	
	for {set x 0} {$x < $data_size} {incr x} {
		#change the address and data to hex
		set hex_add [format "%x" $current_address];
		set hex_data [format "%x" $current_data];
		
		#write the data to the address
		#command 7 is an flash write
		#::bts::bts comm write_port 7 1 [list $base_address_hex $hex_add $hex_data];
		#check if port is open
		if {[::bts::bts comm write_port 7 1 [list $base_address_hex $hex_add $hex_data]]} {
			::bts::nios_stamp::print "Port Not Open!!\n" error;
			set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
			return 1;
		}
		
		#send command to read data back (2) 
		#and wait until we have itn";
		::bts::bts comm write_port 8 1 [list $base_address_hex $hex_add] "::bts::nios_stamp::mem::return_read_data";
		
		#wait until data is returned
		set got_data 0;
		vwait ::bts::nios_stamp::mem::got_data;
		
		#check the data and record the error if there is any
		if {$hex_data != [format "%x" $read_data]} {
			::bts::nios_stamp::print "Wrote 0x$hex_data to Address 0x$hex_add, but read back 0x[format "%x" $read_data]\n";
			set errors(total) [expr $errors(total) + 1];
			#store the error data in an element represented by the error add
			set errors($hex_add) [format "%x" $read_data];
		}
		
		#incr add and shift data
		set current_data [expr $current_data << 1];
		#for now assume 8 bit addressing
		set current_address [expr $current_address + 1];  
		
	}
	
}

#walking ones on address
proc ::bts::nios_stamp::mem::walking_address_test_flash {} {
	#globals
	variable base_address;
	variable end_address;
	variable data_size;
	variable errors;
	variable read_data;
	variable got_data;
	
	#pretty output
	::bts::nios_stamp::print "Walking Ones on Address\n";
	
	#just for here
	set current_data [format "%u" "0xa5"];
	set base_address_hex [format "%x" $base_address];
	
	for {set current_address 1} {[expr $current_address+$base_address] < $end_address} {set current_address [expr $current_address<<1] } {
		#change the address and data to hex
		set hex_add [format "%x" $current_address];
		set hex_data [format "%x" $current_data];
		
		#write the data to the address
		#command 7 is an flash write
		#::bts::bts comm write_port 7 1 [list $base_address_hex $hex_add $hex_data];
		#check if port is open
		if {[::bts::bts comm write_port 7 1 [list $base_address_hex $hex_add $hex_data]]} {
			::bts::nios_stamp::print "Port Not Open!!\n" error;
			set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
			return 1;
		}
		
		
		#send command to read data back (2) 
		#and wait until we have it
		::bts::bts comm write_port 8 1 [list $base_address_hex $hex_add] "::bts::nios_stamp::mem::return_read_data";
		set got_data 0;
		vwait ::bts::nios_stamp::mem::got_data;
		
		#check the data and record the error if there is any
		if {$hex_data != [format "%x" $read_data]} {
			::bts::nios_stamp::print "Wrote 0x$hex_data to Address 0x$hex_add, but read back 0x[format "%x" $read_data]\n";
			set errors(total) [expr $errors(total) + 1];
			#store the error data in an element represented by the error add
			set errors($hex_add) [format "%x" $read_data];
		}
		
		#toggle data
		if {$current_data == [format "%u" "0xa5"]} {
			set current_data [format "%u" "0x5a"];
		} else {
			set current_data [format "%u" "0xa5"];
		}
		
	}
	
}

#erase the entire flash
proc ::bts::nios_stamp::mem::flash_erase {base_address} {
	#globals
	variable read_data;
	variable got_data;
	
	#the flash erase function returns a couple of times. 
	#this requires a continuous function id to be used.
	
	set function_id [::bts::bts comm set_cont_function_id "::bts::nios_stamp::mem::return_read_data"];
	
	#puts $function_id
	
	#erase the flash
	#::bts::bts comm function_id_write_port $function_id A 1 [list $base_address];
	#check if port is open
	if {[::bts::bts comm function_id_write_port $function_id A 1 [list $base_address]]} {
		::bts::nios_stamp::print "Port Not Open!!\n" error;
		set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
		::bts::bts comm unset_cont_function_id $function_id;
		return 1;
	}
		
	
	#wait for verification of flash erase start
	set got_data 0;
	vwait ::bts::nios_stamp::mem::got_data;
	
	::bts::nios_stamp::print "Starting Flash Erase\n";
	
	#wait for completed erase 
	set got_data 0;
	vwait ::bts::nios_stamp::mem::got_data;
	
	::bts::nios_stamp::print "Finished Flash Erase\n";
	::bts::bts comm unset_cont_function_id $function_id;
}

#erase a sector
proc ::bts::nios_stamp::mem::flash_erase_sector {base_address sector_offset} {
	#globals
	variable read_data;
	variable got_data;
	
		#the flash erase function returns a couple of times. 
	#this requires a continuous function id to be used.
	
	set function_id [::bts::bts comm set_cont_function_id "::bts::nios_stamp::mem::return_read_data"];
	
	#puts $function_id
	
	#erase the flash
	#::bts::bts comm function_id_write_port $function_id 9 1 [list [format "%x" $base_address] $sector_offset];
	#check if port is open
	if {[::bts::bts comm function_id_write_port $function_id 9 1 [list [format "%x" $base_address] $sector_offset]]} {
		::bts::nios_stamp::print "Port Not Open!!\n" error;
		set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
		::bts::bts comm unset_cont_function_id $function_id;
		return 1;
	}
	
	#wait for verification of flash erase start
	set got_data 0;
	vwait ::bts::nios_stamp::mem::got_data;
	
	::bts::nios_stamp::print "Starting Flash Erase of sector offset $sector_offset\n";
	
	#wait for completed erase 
	set got_data 0;
	vwait ::bts::nios_stamp::mem::got_data;
	
	::bts::nios_stamp::print "Finished Flash Erase\n";
	::bts::bts comm unset_cont_function_id $function_id;
}


###Ethernet Functions
namespace eval ::bts::nios_stamp::ethernet {
	variable bts_nios_stamp_ethernet;
	
	set bts_nios_stamp_ethernet(ip_address) 0;
	set bts_nios_stamp_ethernet(got_dhcp) 0;
	set bts_nios_stamp_ethernet(end_wait_flag) 0;
	set bts_nios_stamp_ethernet(data_list) "";
	set bts_nios_stamp_ethernet(got_data) 0;
	
}

#ethernet return function
proc ::bts::nios_stamp::ethernet::ether_return {number_list} {
	variable bts_nios_stamp_ethernet;
	
	set bts_nios_stamp_ethernet(data_list) $number_list;
	set bts_nios_stamp_ethernet(got_data) 1;
	#puts $number_list;
}

#get_dhcp address function
proc ::bts::nios_stamp::ethernet::ether_get_dhcp {} {
	variable bts_nios_stamp_ethernet;
	if {$::bts::nios_stamp::bts_nios_stamp_flags(not_in_test)} {
		if {$bts_nios_stamp_ethernet(got_dhcp)} {
			:bts::nios_stamp::print "Already have DHCP Address of $bts_nios_stamp_ethernet(ip_address).\n";
			
		} else {
			set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 0;
			#setup the continuous id function
			set function_id [::bts::bts comm set_cont_function_id "::bts::nios_stamp::ethernet::ether_return"]; 
			
			::bts::nios_stamp::print "Getting DHCP Address\n" bold;
			
			#wait for the responses
			
			set bts_nios_stamp_ethernet(got_data) 0;
			set bts_nios_stamp_ethernet(data_list) "";
			set return_data_id 0;
			
			#send the command
			#check if port is open
			if {[::bts::bts comm function_id_write_port $function_id B 1 0]} {
				::bts::nios_stamp::print "Port Not Open!!\n" error;
				set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
				::bts::bts comm unset_cont_function_id $function_id;
				return 1;
			}
			
			
			set bts_nios_stamp_ethernet(got_dhcp) 1;
			#always send a 3 at the end of ethernet function
			while {$return_data_id != 3} {
				
				vwait ::bts::nios_stamp::ethernet::bts_nios_stamp_ethernet(got_data);
				if {[llength $bts_nios_stamp_ethernet(data_list)] < 2} {
					set return_data_id [lindex $bts_nios_stamp_ethernet(data_list) 0];
					if {$return_data_id == "404"} {
						::bts::nios_stamp::print "Failed to obtain IP Address\n";
						set bts_nios_stamp_ethernet(got_dhcp) 0;
					}
				} else {
					set return_data_id 0;
					
					#got back IP address
					
					set ip_top [format "%u" "0x[lindex $bts_nios_stamp_ethernet(data_list) 0]"];
					set ip_top_mid [format "%u" "0x[lindex $bts_nios_stamp_ethernet(data_list) 1]"];
					set ip_bot_mid [format "%u" "0x[lindex $bts_nios_stamp_ethernet(data_list) 2]"];
					set ip_bot [format "%u" "0x[lindex $bts_nios_stamp_ethernet(data_list) 3]"];
					#puts "$ip_top $ip_top_mid $ip_bot_mid $ip_bot";
					set bts_nios_stamp_ethernet(ip_address) "$ip_top.$ip_top_mid.$ip_bot_mid.$ip_bot";
				}
			}
			if {$bts_nios_stamp_ethernet(got_dhcp)} {
				::bts::nios_stamp::print "DHCP Address obtained.  Address is $bts_nios_stamp_ethernet(ip_address).\n";
			} else {
				::bts::nios_stamp::print "DHCP Failed.\n" error;
			}
			
			set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
			::bts::bts comm unset_cont_function_id $function_id;
		}
		
	} else {
		::bts::nios_stamp::print "Currently running a test!!\n" error;
	}
}

#blink ethernet leds
proc ::bts::nios_stamp::ethernet::ether_blink_leds {} {
	variable bts_nios_stamp_ethernet;
	
	if {$::bts::nios_stamp::bts_nios_stamp_flags(not_in_test)} {
		set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 0;
		
		if {$bts_nios_stamp_ethernet(got_dhcp)} {
			
			::bts::nios_stamp::print "Blinking LEDs.\n" bold;
			
			#setup the continuous id function
			set function_id [::bts::bts comm set_cont_function_id "::bts::nios_stamp::ethernet::ether_return"]; 
			
			#wait for the responses
			
			set bts_nios_stamp_ethernet(got_data) 0;
			set bts_nios_stamp_ethernet(data_list) "";
			set return_data_id 0;
			
			#send the command
			#check if port is open
			if {[::bts::bts comm function_id_write_port $function_id C 1 0]} {
				::bts::nios_stamp::print "Port Not Open!!\n" error;
				set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
				::bts::bts comm unset_cont_function_id $function_id;
				return 1;
			}
			
			#always send a 3 at the end of ethernet function
			while {$return_data_id != 3} {
				#wait for data back
				vwait ::bts::nios_stamp::ethernet::bts_nios_stamp_ethernet(got_data);
				
				set return_data_id [lindex $bts_nios_stamp_ethernet(data_list) 0];
				
			}
			
			::bts::nios_stamp::print "Done.\n" bold;
			
			::bts::bts comm unset_cont_function_id $function_id;
			
		} else {
			::bts::nios_stamp::print "DHCP address has not been obtained!\n" error;
		}
		set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
		
	} else {
		::bts::nios_stamp::print "Currently running a test!!\n" error;
	}
}
	

#kill plugs
proc ::bts::nios_stamp::ethernet::ether_kill {} {
	variable bts_nios_stamp_ethernet;
	
	if {$::bts::nios_stamp::bts_nios_stamp_flags(not_in_test)} {
		
		set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 0;
		
		if {$bts_nios_stamp_ethernet(got_dhcp)} {
			::bts::nios_stamp::print "Stopping Plugs.\n" bold;
			
			#setup the continuous id function
			set function_id [::bts::bts comm set_cont_function_id "::bts::nios_stamp::ethernet::ether_return"]; 
			
			#wait for the responses
			
			set bts_nios_stamp_ethernet(got_data) 0;
			set bts_nios_stamp_ethernet(data_list) "";
			set return_data_id 0;
			
			#send the command
			#check if port is open
			if {[::bts::bts comm function_id_write_port $function_id D 1 0]} {
				::bts::nios_stamp::print "Port Not Open!!\n" error;
				set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
				::bts::bts comm unset_cont_function_id $function_id;
				return 1;
			}
			
			#always send a 3 at the end of ethernet function
			while {$return_data_id != 3} {
				#wait for data back
				vwait ::bts::nios_stamp::ethernet::bts_nios_stamp_ethernet(got_data);
				
				set return_data_id [lindex $bts_nios_stamp_ethernet(data_list) 0];
				
			}
			::bts::nios_stamp::print "Plugs Stopped.\n" bold;
			
			set bts_nios_stamp_ethernet(got_dhcp) 0;
			
			set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
			
			::bts::bts comm unset_cont_function_id $function_id;
			
		} else {
			::bts::nios_stamp::print "DHCP address has not been obtained!\n" error;
		}
	} else {
		::bts::nios_stamp::print "Currently running a test!!\n" error;
	}
}

#ping
proc ::bts::nios_stamp::ethernet::ether_ping {type} {
	variable bts_nios_stamp_ethernet;
	if {$::bts::nios_stamp::bts_nios_stamp_flags(not_in_test)} {
		
		set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 0;
		
		if {$bts_nios_stamp_ethernet(got_dhcp)} {
			::bts::nios_stamp::print "Starting Ping of Board\n!" bold;
			switch -exact -- $type {
				windows {
					catch {exec ping $bts_nios_stamp_ethernet(ip_address)} ping_output;
				}
				unix {
					catch {exec ping -c 4 $bts_nios_stamp_ethernet(ip_address)} ping_output;
				}
				default {
					::bts::nios_stamp::print "Invalid ping type!\n" error;
					set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
					return;
				}
			}
			
			::bts::nios_stamp::print "$ping_output";
			::bts::nios_stamp::print "Done.\n" bold;
			
		} else {
			::bts::nios_stamp::print "DHCP address has not been obtained!\n" error;
		}
		
		set ::bts::nios_stamp::bts_nios_stamp_flags(not_in_test) 1;
		
	} else {
		::bts::nios_stamp::print "Currently running a test!!\n" error;
	}
	
}
